local addon, rabc = ...

function rabc.createAbilityList()
	rabc.AbilityList = {}
	local abilities = nil
	local abilities = Inspect.Ability.New.List()
	if abilities == nil then return end
	if Inspect.System.Secure() == true then return end
	Command.System.Watchdog.Quiet() 
	local details = Inspect.Ability.New.Detail(abilities)
	if details ~= nil then
		for k, a in pairs(details) do
			if not a then
			elseif a.passive then
			elseif a.racial and rabcSavedSettings.include[1] == false then
			elseif a.continuous then
			elseif string.find(a.name, "Augmentation") ~= nil then
			elseif string.find(a.name, "Track") ~= nil then
			elseif string.find(a.name, "Patron") ~= nil and rabcSavedSettings.include[3] == false then
			elseif string.find(a.name, "Summon") ~= nil and rabcSavedSettings.include[2] == false then
			elseif string.find(a.name, "Role") ~= nil then
			elseif string.find(a.name, "Lure") ~= nil then
			elseif string.find(a.name, "Toggle") ~= nil then
			elseif string.find(a.name, "Wardstone") ~= nil then
			elseif string.find(a.name, "Salvage") ~= nil then
			else
				table.insert(rabc.AbilityList, {name = a.name, icon = a.icon, id = a.id})
			end
		end
		table.sort(rabc.AbilityList, function(a,b) return a.name < b.name end)
		rabc.CreateAbilities()
	end
end

function rabc.CreateAbilities(adetails)
	local abilitycount = 0
	rabc.AbilityFrame:SetHeight(0)
	for i = 1, 40 do
		rabc.AbilityIcons[i]:SetVisible(false)
		rabc.AbilityIconsText[i]:SetVisible(false)
	end
	for k, v in pairs(rabc.AbilityList) do
		if rabc.AbilityIcons[k] == nil then
			rabc.AbilityIcons[k] = UI.CreateFrame("Texture", "AbilityIcons", rabc.AbilityFrame)
			rabc.AbilityIconsText[k] = UI.CreateFrame("Text", "AbilityIconsText", rabc.AbilityIcons[k])
		end
		rabc.AbilityIcons[k]:SetPoint("TOPLEFT", rabc.AbilityFrame, "TOPLEFT", 0, abilitycount*32)
		rabc.AbilityIconsText[k]:SetPoint("LEFTCENTER", rabc.AbilityIcons[k], "RIGHTCENTER", 0, 0)

		rabc.AbilityIcons[k].aname = v.name
		rabc.AbilityIcons[k].aicon = v.icon
		rabc.AbilityIcons[k].aid = v.id
		rabc.AbilityIconsText[k].aname = v.name
		rabc.AbilityIconsText[k].aicon = v.icon
		rabc.AbilityIconsText[k].aid = v.id

		rabc.AbilityIcons[k]:SetVisible(true)
		rabc.AbilityIconsText[k]:SetVisible(true)
		if string.len(rabc.AbilityIcons[k].aname) > 18 then 
			rabc.AbilityIconsText[k]:SetText(string.sub(rabc.AbilityIcons[k].aname, 1, 18) .. "...")
		else	
			rabc.AbilityIconsText[k]:SetText(rabc.AbilityIcons[k].aname)
		end
		rabc.AbilityIconsText[k]:SetFontSize(16)
		rabc.AbilityIconsText[k]:SetLayer(5)
		rabc.AbilityIcons[k]:SetTexture("Rift", rabc.AbilityIcons[k].aicon)
		rabc.AbilityIcons[k]:SetWidth(24)
		rabc.AbilityIcons[k]:SetHeight(24)
		rabc.AbilityIcons[k]:SetLayer(5)

		rabc.AbilityIcons[k]:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			if rabc.barsel == nil then return end
			rabc.IconDown(rabc.AbilityIcons[k].aname, rabc.AbilityIcons[k].aicon, rabc.AbilityIcons[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Down")
		rabc.AbilityIcons[k]:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			rabc.IconDrag(rabc.AbilityIcons[k].aname, rabc.AbilityIcons[k].aicon, rabc.AbilityIcons[k].aid, k)
		end, "Event.UI.Input.Mouse.Cursor.Move")
		rabc.AbilityIcons[k]:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			rabc.IconUp(rabc.AbilityIcons[k].aname, rabc.AbilityIcons[k].aicon, rabc.AbilityIcons[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Up")
		rabc.AbilityIcons[k]:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function(self, h)
			rabc.IconUp(rabc.AbilityIcons[k].aname, rabc.AbilityIcons[k].aicon, rabc.AbilityIcons[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Upoutside")
		
		
		rabc.AbilityIconsText[k]:EventAttach(Event.UI.Input.Mouse.Left.Down, function(self, h)
			if rabc.barsel == nil then return end
			rabc.IconDown(rabc.AbilityIconsText[k].aname, rabc.AbilityIconsText[k].aicon, rabc.AbilityIconsText[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Down")
		rabc.AbilityIconsText[k]:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(self, h)
			rabc.IconDrag(rabc.AbilityIconsText[k].aname, rabc.AbilityIconsText[k].aicon, rabc.AbilityIconsText[k].aid, k)
		end, "Event.UI.Input.Mouse.Cursor.Move")
		rabc.AbilityIconsText[k]:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			rabc.IconUp(rabc.AbilityIconsText[k].aname, rabc.AbilityIconsText[k].aicon, rabc.AbilityIconsText[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Up")
		rabc.AbilityIconsText[k]:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function(self, h)
			rabc.IconUp(rabc.AbilityIconsText[k].aname, rabc.AbilityIconsText[k].aicon, rabc.AbilityIconsText[k].aid, k)
		end, "Event.UI.Input.Mouse.Left.Upoutside")
		abilitycount = k
	end
	rabc.AbilityFrame:SetHeight(abilitycount*32)
end
rabc.mDown = false
function rabc.IconDown(aname, aicon, aid, index)
	rabc.AbilityIconsCopy:SetTexture("Rift", aicon)
	rabc.AbilityIconsCopy:SetLayer(6)
	rabc.spellholding = {name = aname, icon = aicon, id = aid, slot = index}
	rabc.mDown = true
	local m = Inspect.Mouse()
	rabc.AbilityIconsCopy:SetPoint("TOPLEFT", UIParent, "TOPLEFT", m.x-12, m.y-12)
	rabc.AbilityIconsCopy:SetVisible(true)
end
function rabc.IconDrag(aname, aicon, aid, index)
	if rabc.mDown then
		local m = Inspect.Mouse()
		rabc.AbilityIconsCopy:SetPoint("TOPLEFT", UIParent, "TOPLEFT", m.x-12, m.y-12)
	end
end
function rabc.IconUp(aname, aicon, aid, index)
	if rabc.spellholding then
		rabc.AbilityIconsCopy:ClearAll()
		rabc.AbilityIconsCopy:SetVisible(false)
		rabc.mDown = false
	end
end

