local addon, rabc = ...

function rabc.createOptions()
	if rabc.isincombat then return end
	rabc.config:SetPoint("TOPCENTER", UIParent, "TOPCENTER")
	rabc.config:SetWidth(700)
	rabc.config:SetHeight(700)
	rabc.config:SetVisible(rabcSavedSettings.locked == false)

	rabc.configOptionsTab:SetPoint("TOPLEFT", rabc.config, "TOPLEFT", 15, 50)
	rabc.configOptionsTab:SetPoint("BOTTOMRIGHT", rabc.config, "BOTTOMRIGHT", -15, -15)
	function rabc.configOptionsTab.Event.TabSelect()
	end
-----------Tab A---------------	
	
	rabc.configSliderText1:SetPoint("TOPCENTER", rabc.configOptionsA, "TOPCENTER", 0, 10)	
	rabc.configSliderText1:SetFontSize(30)	
	rabc.configSliderText1:SetText("Welcome to RiftActionCooldowns")	
	rabc.configSliderText1:SetEffectGlow(rabc.glowTable)
	rabc.configSliderText2:SetPoint("BOTTOMCENTER", rabc.configOptionsA, "BOTTOMCENTER")	
	rabc.configSliderText2:SetFontSize(16)	
	rabc.configSliderText2:SetText("Use the sliders to position the MainBar overlay over your MainBar. \n                        Lock the overlay when done.")	
	rabc.configSliderL:SetPoint("LEFTCENTER", rabc.configOptionsA, "LEFTCENTER", 20, 0)
	rabc.configSliderL:SetRange(0, 100)
	rabc.configSliderL:SetPosition(rabcSavedSettings.mainl)
	rabc.configSliderT:SetPoint("TOPCENTER", rabc.configOptionsA, "TOPCENTER", 0, 200) 
	rabc.configSliderT:SetRange(0, 100)
	rabc.configSliderT:SetPosition(rabcSavedSettings.maint)
	rabc.configSliderR:SetPoint("RIGHTCENTER", rabc.configOptionsA, "RIGHTCENTER", -20, 0)
	rabc.configSliderR:SetRange(0, 100)
	rabc.configSliderR:SetPosition(rabcSavedSettings.mainr)
	rabc.configSliderB:SetPoint("BOTTOMCENTER", rabc.configOptionsA, "BOTTOMCENTER", 0, -200)	 
	rabc.configSliderB:SetRange(0, 100)
	rabc.configSliderB:SetPosition(rabcSavedSettings.mainb)
	rabc.configSliderButton:SetPoint("BOTTOMCENTER", rabc.configOptionsA, "BOTTOMCENTER", 0, -100)	
	if rabcSavedSettings.locked == true then
		rabc.configSliderButton:SetText("Unlock Overlay")
		rabc.configSliderL:SetEnabled(false)
		rabc.configSliderT:SetEnabled(false)
		rabc.configSliderR:SetEnabled(false)
		rabc.configSliderB:SetEnabled(false)
	else
		rabc.configSliderButton:SetText("Lock Overlay")
	end
	function rabc.configSliderL.Event.SliderChange()
		if rabcSavedSettings.locked == true then rabc.configSliderL:SetPosition(rabcSavedSettings.mainl) return end
		rabcSavedSettings.mainl = rabc.configSliderL:GetPosition()
		rabc.mainab[1]:SetPoint("TOPLEFT", UI.Native.BarMain, "TOPLEFT", rabcSavedSettings.mainl, rabcSavedSettings.maint)
		rabc.mainab[1]:SetPoint("BOTTOMRIGHT", UI.Native.BarMain, "BOTTOMRIGHT", -(rabcSavedSettings.mainr), -(rabcSavedSettings.mainb))
		rabc.createSlots()
	end
	function rabc.configSliderT.Event.SliderChange()
		if rabcSavedSettings.locked == true then rabc.configSliderT:SetPosition(rabcSavedSettings.maint) return end
		rabcSavedSettings.maint = rabc.configSliderT:GetPosition()
		rabc.mainab[1]:SetPoint("TOPLEFT", UI.Native.BarMain, "TOPLEFT", rabcSavedSettings.mainl, rabcSavedSettings.maint)
		rabc.mainab[1]:SetPoint("BOTTOMRIGHT", UI.Native.BarMain, "BOTTOMRIGHT", -(rabcSavedSettings.mainr), -(rabcSavedSettings.mainb))
		rabc.createSlots()
	end
	function rabc.configSliderR.Event.SliderChange()
		if rabcSavedSettings.locked == true then rabc.configSliderR:SetPosition(rabcSavedSettings.mainr) return end
		rabcSavedSettings.mainr = rabc.configSliderR:GetPosition()
		rabc.mainab[1]:SetPoint("TOPLEFT", UI.Native.BarMain, "TOPLEFT", rabcSavedSettings.mainl, rabcSavedSettings.maint)
		rabc.mainab[1]:SetPoint("BOTTOMRIGHT", UI.Native.BarMain, "BOTTOMRIGHT", -(rabcSavedSettings.mainr), -(rabcSavedSettings.mainb))
		rabc.createSlots()
	end
	function rabc.configSliderB.Event.SliderChange()
		if rabcSavedSettings.locked == true then rabc.configSliderB:SetPosition(rabcSavedSettings.mainb) return end
		rabcSavedSettings.mainb = rabc.configSliderB:GetPosition()
		rabc.mainab[1]:SetPoint("TOPLEFT", UI.Native.BarMain, "TOPLEFT", rabcSavedSettings.mainl, rabcSavedSettings.maint)
		rabc.mainab[1]:SetPoint("BOTTOMRIGHT", UI.Native.BarMain, "BOTTOMRIGHT", -(rabcSavedSettings.mainr), -(rabcSavedSettings.mainb))
		rabc.createSlots()
	end
	rabc.configSliderButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
		if rabcSavedSettings.locked == true then
			rabcSavedSettings.locked = false
			rabc.mainab[1]:SetVisible(true)
			rabc.configSliderButton:SetText("Lock Overlay")
			rabc.configSliderL:SetEnabled(true)
			rabc.configSliderT:SetEnabled(true)
			rabc.configSliderR:SetEnabled(true)
			rabc.configSliderB:SetEnabled(true)
		else
			rabcSavedSettings.locked = true
			rabc.mainab[1]:SetVisible(false)
			rabc.configSliderButton:SetText("Unlock Overlay")
			rabc.configSliderL:SetEnabled(false)
			rabc.configSliderT:SetEnabled(false)
			rabc.configSliderR:SetEnabled(false)
			rabc.configSliderB:SetEnabled(false)
		end
	end, "BarLocked")

-----------Tab B---------------	
	rabc.AbilityFrameRefresh:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 140, 565)
	rabc.AbilityFrameRefresh:SetText("Refresh List")
	rabc.AbilityFrameRefresh:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rabc.createAbilityList() end, "ButtonClick")
	rabc.AbilityListScroll:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 110, 100)
	rabc.AbilityListScroll:SetBackgroundColor(0, 0, 0, 0.8)
	rabc.AbilityListScroll:SetWidth(225)
	rabc.AbilityListScroll:SetHeight(470)
	
	rabc.configOptionsBHelpText:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 150, 5)
	rabc.configOptionsBHelpText:SetWordwrap(true)
	rabc.configOptionsBHelpText:SetWidth(500)
	rabc.configOptionsBHelpText:SetHeight(90)
	rabc.configOptionsBHelpText:SetFontSize(16)
	rabc.configHelpTextString = {"Select the Bar on left, Drag Ability to a Slot on right that corresponds with your actionbars. Right-Click the slot to remove ability. Select Macro to set up multiple spell tracking on that slot.",
								"Drag Abilities over and place in order just like you would a macro with cooldowns first and your spam ability last. Right-click to remove a spell"}
	rabc.configOptionsBHelpText:SetText(rabc.configHelpTextString[1])
	rabc.configOptionsBText:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 460, 100)
	rabc.configOptionsBText:SetFontSize(16)
	rabc.configOptionsBText:SetText("Role #" .. rabcSavedSettings.set)
	rabc.configAbilityFrame:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 345, 100)
	rabc.configAbilityFrame:SetWidth(300)
	rabc.configAbilityFrame:SetHeight(500)
	rabc.configAbilityFrame:SetBackgroundColor(0, 0, 0, 0.1)
	rabc.configMacroFrame:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 345, 100)
	rabc.configMacroFrame:SetWidth(300)
	rabc.configMacroFrame:SetHeight(500)
	rabc.configMacroFrame:SetBackgroundColor(0, 0, 0, 0.1)
	rabc.configMacroFrame:SetVisible(false)
	rabc.MacroAcceptButton:SetPoint("BOTTOMLEFT", rabc.configMacroFrame, "BOTTOMLEFT")
	rabc.MacroAcceptButton:SetText("Accept")
	rabc.MacroCancelButton:SetPoint("BOTTOMRIGHT", rabc.configMacroFrame, "BOTTOMRIGHT")
	rabc.MacroCancelButton:SetText("Cancel")
for i = 1, 40 do
		rabc.AbilityIcons[i]:SetPoint("TOPLEFT", rabc.AbilityFrame, "TOPLEFT", 0, (i - 1) * 32)
		rabc.AbilityIconsText[i]:SetPoint("LEFTCENTER", rabc.AbilityIcons[i], "RIGHTCENTER", 0, 0)
end
	rabc.AbilityListScroll:SetContent(rabc.AbilityFrame)

	for i = 1, 11 do
		rabc.OptionsRadioTabA[i]:SetPoint("TOPLEFT", rabc.configOptionsB, "TOPLEFT", 5, 100 + (40 * (i - 1)))
		rabc.OptionsRadioTabA[i]:SetFontSize(16)
		local text = select(i, "Main Bar", "Bottom 1", "Bottom 2", "Bottom 3", "Bottom 4", "Bottom 5", "Bottom 6", "Side 1", "Side 2", "Side 3", "Side 4")
		rabc.OptionsRadioTabA[i]:SetText(text)
	end
	for i = 1, 12 do
		rabc.OptionsTextATabA[i]:SetPoint("TOPLEFT", rabc.configAbilityFrame, "TOPLEFT", 5, 25 + (40 * (i - 1)))
		rabc.OptionsTextATabA[i]:SetText("Slot " .. tostring(i))
		rabc.OptionsTextATabA[i]:SetHeight(20)
		rabc.OptionsTextATabA[i]:SetWidth(140)
		rabc.OptionsTextATabA[i]:SetFontSize(16)
		rabc.OptionsTextBTabA[i]:SetPoint("TOPLEFT", rabc.configAbilityFrame, "TOPLEFT", 75, 25 + (40 * (i - 1)))
		rabc.OptionsTextBTabA[i]:SetBackgroundColor(0, 0, 0, .8)
		rabc.OptionsTextBTabA[i]:SetHeight(30)
		rabc.OptionsTextBTabA[i]:SetWidth(140)
		rabc.OptionsTextBTabA[i]:SetFontSize(16)
		rabc.OptionsCheckTabA[i]:SetPoint("TOPLEFT", rabc.configAbilityFrame, "TOPLEFT", 225, 25 + (40 * (i - 1)))
		rabc.OptionsCheckTabA[i]:SetText("Macro")
		rabc.OptionsCheckTabA[i]:SetLayer(2)
		rabc.OptionsCheckTabA[i]:SetFontSize(16)
		rabc.MacroEditButton[i]:SetPoint("TOPLEFT", rabc.configAbilityFrame, "TOPLEFT", 220, 25 + (40 * (i - 1)))
		rabc.MacroEditButton[i]:SetText("Edit")
		rabc.MacroEditButton[i]:SetLayer(3)
		rabc.MacroEditButton[i]:SetWidth(80)
		rabc.MacroEditButton[i]:SetHeight(30)
		rabc.MacroEditButton[i]:SetVisible(false)
		rabc.OptionsTextCTabA[i]:SetPoint("TOPLEFT", rabc.configMacroFrame, "TOPLEFT", 75, (40 * (i - 1)))
		rabc.OptionsTextCTabA[i]:SetBackgroundColor(0, 0, 0, .8)
		rabc.OptionsTextCTabA[i]:SetHeight(30)
		rabc.OptionsTextCTabA[i]:SetWidth(140)
		rabc.OptionsTextCTabA[i]:SetFontSize(16)
	end	
	for i = 1, 12 do
		rabc.OptionsTextBTabA[i]:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			rabc.slotsel = i
			if rabc.spellholding ~= nil then
				rabc.OptionsTextBTabA[i]:SetText(rabc.spellholding.name)
				rabc.MacroEditButton[rabc.slotsel]:SetVisible(false)
				rabc.OptionsCheckTabA[rabc.slotsel]:SetChecked(false)
				rabc.AbilityIconsCopy:ClearAll()
				rabc.AbilityIconsCopy:SetVisible(false)
				index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(i)
				rabcSavedAbils[index] = {id = rabc.spellholding.id, icon = rabc.spellholding.icon, name = rabc.spellholding.name, start = 0, duration = 0, set = rabcSavedSettings.set, bar = rabc.barsel, slot = i, ismacro = false, watch = false}
				rabc.spellholding = nil
			end
		end, "Event.UI.Input.Mouse.Left.Up")
		rabc.OptionsTextBTabA[i]:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
			if rabc.barsel ~= nil then
				index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(i)
				rabc.MacroEditButton[i]:SetVisible(false)
				rabc.OptionsCheckTabA[i]:SetChecked(false)
				rabcSavedAbils[index] = nil
				rabc.OptionsTextBTabA[i]:SetText("")
			end
		end, "Event.UI.Input.Mouse.Right.Click")
	end
	function rabc.OptionsSetTabA.Event:RadioButtonChange()
		if rabc.lastbarsel == nil then rabc.lastbarsel = rabc.OptionsSetTabA:GetSelectedIndex() else rabc.lastbarsel = rabc.barsel end
		rabc.barsel = rabc.OptionsSetTabA:GetSelectedIndex()
		for i = 1, 12 do
			rabc.OptionsCheckTabA[i]:SetEnabled(true)
			rabc.MacroEditButton[i]:SetVisible(false)
			rabc.OptionsCheckTabA[i]:SetChecked(false) 
		end
		for i = 1, 12 do
			index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(i)
			if rabcSavedAbils[index] == nil then
			rabc.OptionsTextBTabA[i]:SetText("")
			else
			rabc.OptionsTextBTabA[i]:SetText(rabcSavedAbils[index].name)
			if rabcSavedAbils[index].ismacro == true then rabc.MacroEditButton[i]:SetVisible(true) end
			end
		end
		rabc.mainab[rabc.lastbarsel]:SetVisible(false)
		rabc.mainab[rabc.barsel]:SetVisible(true)
	end
	for i = 1, 12 do
		rabc.OptionsCheckTabA[i].Event.CheckboxChange = function()
			if rabc.OptionsCheckTabA[i]:GetChecked() == true and rabc.barsel ~= nil then
				rabc.MacroEditButton[i]:SetVisible(true)
				rabc.slotsel = i
				rabc.index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(rabc.slotsel)
			end
		end
	end
	for i = 1, 12 do
		rabc.MacroEditButton[i]:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
			rabc.configOptionsBHelpText:SetText(rabc.configHelpTextString[2])
			rabc.configMacroFrame:SetVisible(true)
			rabc.slotsel = i
			rabc.index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(rabc.slotsel)
			for i = 1, 12 do
				rabc.OptionsTextCTabA[i]:SetText("")
				if rabcSavedAbils[rabc.index] and rabcSavedAbils[rabc.index][i] then
					if rabcSavedAbils[rabc.index][i].name then
					rabc.OptionsTextCTabA[i]:SetText(rabcSavedAbils[rabc.index][i].name)
					rabctempMacroTable[i] = {id = rabcSavedAbils[rabc.index][i].id, icon = rabcSavedAbils[rabc.index][i].icon, name = rabcSavedAbils[rabc.index][i].name, start = 0, duration = 0, set = rabcSavedSettings.set, bar = rabc.barsel, slot = rabc.slotsel, watch = false}
					else
					rabc.OptionsTextCTabA[i]:SetText("")
					end
				end
			end
				
			rabc.configAbilityFrame:SetVisible(false)
			
		end, "ButtonClick")
	end
	for i = 1, 12 do
		rabc.OptionsTextCTabA[i]:EventAttach(Event.UI.Input.Mouse.Left.Up, function(self, h)
			if rabc.spellholding ~= nil then
				rabc.OptionsTextCTabA[i]:SetText(rabc.spellholding.name)
				rabc.AbilityIconsCopy:ClearAll()
				rabc.AbilityIconsCopy:SetVisible(false)
				rabctempMacroTable[i] = {id = rabc.spellholding.id, icon = rabc.spellholding.icon, name = rabc.spellholding.name, start = 0, duration = 0, set = rabcSavedSettings.set, bar = rabc.barsel, slot = i, watch = false}
				rabc.spellholding = nil
			else
				rabc.OptionsTextBTabA[i]:SetText("")
			end
		end, "Event.UI.Input.Mouse.Left.Up")
	end
	for i = 1, 12 do
		rabc.OptionsTextCTabA[i]:EventAttach(Event.UI.Input.Mouse.Right.Click, function(self, h)
				rabc.OptionsTextCTabA[i]:SetText("")
				rabctempMacroTable[i] = nil
				rabc.spellholding = nil
		end, "Event.UI.Input.Mouse.Left.Up")
	end
	rabc.MacroAcceptButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
			rabc.index = tostring(rabcSavedSettings.set) .. "_" .. tostring(rabc.barsel) .. "_" .. tostring(rabc.slotsel)
			rabcSavedAbils[rabc.index] = {id = "", icon = "", name = "Macro", start = 0, duration = 0, set = rabcSavedSettings.set, bar = rabc.barsel, slot = rabc.slotsel, ismacro = true, watch = false}
			for i = 1, 12 do
				if rabctempMacroTable[i] ~= nil then
			table.insert(rabcSavedAbils[rabc.index], rabctempMacroTable[i])
				end
			end
			rabc.configOptionsBHelpText:SetText(rabc.configHelpTextString[1])
			rabc.OptionsTextBTabA[rabc.slotsel]:SetText(rabcSavedAbils[rabc.index].name)
			rabc.configMacroFrame:SetVisible(false)
			rabc.configAbilityFrame:SetVisible(true)
	end, "ButtonClick")
	rabc.MacroCancelButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
		rabc.configOptionsBHelpText:SetText(rabc.configHelpTextString[1])
			rabc.configMacroFrame:SetVisible(false)
			rabc.configAbilityFrame:SetVisible(true)
	end, "ButtonClick")
-------------------Tab C------------
	
	rabc.configFontSlider:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 350, 140)
	rabc.configFontSlider:SetRange(12, 60)
	rabc.configFontSlider:SetWidth(200)
	rabc.configFontSlider:SetPosition(rabcSavedColors[1].f)
	rabc.configOptionsTextBTabB[1]:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 300, 140)
	rabc.configOptionsTextBTabB[1]:SetFontSize(16)
	rabc.configOptionsTextBTabB[1]:SetText("Font")

	rabc.configColorSelector:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 20, 50)
	rabc.configColorSelector:SetWidth(220)
	rabc.configColorSelector:SetHeight(150)
	rabc.configColorSelector:SetBorder(1, 1, 1, 1, 1)
	local cselectlist = {"Over 60 seconds", "Between 60 and 10 seconds", "Under 10 seconds"}
	rabc.colorsel = 1
	rabc.configColorSelector:SetItems(cselectlist)
	rabc.configColorSelector:SetSelectedIndex(1)
	rabc.configColorSelector:SetFontSize(16)

	rabc.configOptionsFrameTabB:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 300, 50)
	rabc.configOptionsFrameTabB:SetHeight(80)
	rabc.configOptionsFrameTabB:SetWidth(220)
	rabc.configOptionsFrameTabB:SetBackgroundColor(0, 0, 0, 0.5)
	for i = 1, 3 do
		rabc.configOptionsTextATabB[i]:SetPoint("LEFTCENTER", rabc.configOptionsFrameTabB, "LEFTCENTER", (15 + (75 * (i - 1))), 0)
		rabc.configOptionsTextATabB[i]:SetFontSize(rabcSavedColors[i].f)
		rabc.configOptionsTextATabB[i]:SetFontColor(rabcSavedColors[i].r, rabcSavedColors[i].g, rabcSavedColors[i].b )
		local text  = select(i, "59:39", "24", "8")
		rabc.configOptionsTextATabB[i]:SetText(text)
		rabc.configOptionsTextATabB[i]:SetLayer(1)
	end
	rabc.OptionsColorFrameTabC:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 160, 220)
	function rabc.colorreturn(r, g, b)
		if rabc.colorsel == nil then return end
		rabcSavedColors[rabc.colorsel].r = r
		rabcSavedColors[rabc.colorsel].g = g
		rabcSavedColors[rabc.colorsel].b = b
		rabc.configOptionsTextATabB[rabc.colorsel]:SetFontColor(rabcSavedColors[rabc.colorsel].r, rabcSavedColors[rabc.colorsel].g, rabcSavedColors[rabc.colorsel].b)
	end
	Library.ColorChooser.CreateWidget(rabc.OptionsColorFrameTabC, rabc.colorreturn, 8)

	rabc.configOptionsTextBTabB[2]:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 140, 300)
	rabc.configOptionsTextBTabB[2]:SetFontSize(16)
	rabc.configOptionsTextBTabB[2]:SetText("Select item from list, then select color from palette.")

	rabc.configOptionsSeperatorATabC:SetTexture("Rift", "header_divider.png.dds")
	rabc.configOptionsSeperatorATabC:SetPoint("TOPCENTER", rabc.configOptionsC, "TOPCENTER", 0, 320)
	rabc.configOptionsSeperatorATabC:SetWidth(500)
	rabc.configOptionsSeperatorATabC:SetHeight(10)

	for i = 1, 2 do
		rabc.OptionsRadioATabC[i]:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 5, 340 + (25 * (i - 1)))
		rabc.OptionsRadioATabC[i]:SetFontSize(16)
		local text = select(i, "Show next Ability in Macro not on Cooldown", "Show next Ability in Macro on Cooldown")
		rabc.OptionsRadioATabC[i]:SetText(text)
	end
	rabc.configOptionsSeperatorBTabC:SetTexture("Rift", "header_divider.png.dds")
	rabc.configOptionsSeperatorBTabC:SetPoint("TOPCENTER", rabc.configOptionsC, "TOPCENTER", 0, 400)
	rabc.configOptionsSeperatorBTabC:SetWidth(500)
	rabc.configOptionsSeperatorBTabC:SetHeight(10)

	for i = 1, 2 do
		rabc.OptionsRadioBTabC[i]:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 5, 440 + (25 * (i - 1)))
		rabc.OptionsRadioBTabC[i]:SetFontSize(16)
		local text = select(i, "Show timer format [mm]:[ss]", "Show timer format [ss]")
		rabc.OptionsRadioBTabC[i]:SetText(text)
	end
	for i = 1, 3 do
		rabc.OptionsCheckCTabC[i]:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 300, 440 + (25 * (i - 1)))
		rabc.OptionsCheckCTabC[i]:SetFontSize(16)
		local text = select(i, "Include Racial Abilities", "Include any abilities with Summon in name", "Include and abilities with Patron in name")
		rabc.OptionsCheckCTabC[i]:SetText(text)
		rabc.OptionsCheckCTabC[i]:SetChecked(rabcSavedSettings.include[i])
		rabc.OptionsCheckCTabC[i].Event.CheckboxChange = function()
		if rabc.config:GetVisible() == true then rabcSavedSettings.include[i] = rabc.OptionsCheckCTabC[i]:GetChecked() end
		end
	end

	rabc.OptionsCheckTabC:SetPoint("TOPLEFT", rabc.configOptionsC, "TOPLEFT", 5, 520)
	rabc.OptionsCheckTabC:SetFontSize(16)
	rabc.OptionsCheckTabC:SetText("Show Growth Animation")
	rabc.OptionsCheckTabC:SetChecked(rabcSavedSettings.animate)
	rabc.OptionsCheckTabC.Event.CheckboxChange = function()
		if rabc.config:GetVisible() == true then rabcSavedSettings.animate = rabc.OptionsCheckTabC:GetChecked() end
	end
	rabc.OptionsRadioATabC[rabcSavedSettings.macroshow]:SetSelected(true)
	rabc.OptionsRadioBTabC[rabcSavedSettings.timer]:SetSelected(true)

	function rabc.OptionsSetATabC.Event:RadioButtonChange()
		rabcSavedSettings.macroshow = rabc.OptionsSetATabC:GetSelectedIndex()
	end
	function rabc.OptionsSetBTabC.Event:RadioButtonChange()
		rabcSavedSettings.timer = rabc.OptionsSetBTabC:GetSelectedIndex()
	end
	rabc.configColorSelector.Event.ItemSelect = function(view, item)
		rabc.colorsel = rabc.configColorSelector:GetSelectedIndex()
		rabc.configFontSlider:SetPosition(rabcSavedColors[rabc.colorsel].f)
	end
	function rabc.configFontSlider.Event.SliderChange()
		rabcSavedColors[rabc.colorsel].f = rabc.configFontSlider:GetPosition()
		rabc.configOptionsTextATabB[rabc.colorsel]:SetFontSize(rabcSavedColors[rabc.colorsel].f)
	end

-------------------------------
	rabc.config:SetCloseButtonVisible(true)
	function rabc.config.Event.Close()
		for i = 1, 11 do
		rabc.mainab[i]:SetVisible(false)
		end
	end
end
