local addon, rabc = ...
-- Use for any addon, just change the local rabc and 2 rabc.function names.
local windowdragActive = false
local windowResizeActive = false
local clickOffset = {x = 0, y = 0}
local resizeOffset = {x = 0, y = 0}

function rabc.dragframe(window, callback)
	window:EventAttach(Event.UI.Input.Mouse.Left.Down, function() 
		windowdragActive = true
		local mouseStatus = Inspect.Mouse()
		win_x = window:GetLeft()
		win_y = window:GetTop()

		clickOffset["x"] = mouseStatus.x - win_x
		clickOffset["y"] = mouseStatus.y - win_y
	end, "DragLeftDown" )
	window:EventAttach(Event.UI.Input.Mouse.Left.Up, function()	windowdragActive = false end, "DragLeftUp")
	window:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function() windowdragActive = false end, "DragLeftUpOutside")
	window:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(frame, hEvent,x,y)
		if windowdragActive == true then
			new_x = x - clickOffset["x"]
			new_y = y - clickOffset["y"]
			if callback then callback(window, new_x, new_y) end
		end
	end, "MouseMove")
end

function rabc.resizeframe(window, parent, callback)
	window:EventAttach(Event.UI.Input.Mouse.Left.Down, function() 
		windowResizeActive = true
		local mouseStatus = Inspect.Mouse()
		clickOffset["x"] = mouseStatus.x
		clickOffset["y"] = mouseStatus.y
		resizeOffset["x"] = parent:GetWidth()
		resizeOffset["y"] = parent:GetHeight()
	end, "ResizeLeftDown" )
	window:EventAttach(Event.UI.Input.Mouse.Left.Up, function() windowResizeActive = false end, "ResizeMouseUp" )
	window:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function() windowResizeActive = false end, "ResizeLeftUpOutside" )
	window:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(frame, hEvent,x,y)
		if windowResizeActive == true then
			new_x = math.ceil(resizeOffset["x"] + (x - clickOffset["x"]))
			new_y = math.ceil(resizeOffset["y"] + (y - clickOffset["y"]))
			if callback then callback(window, parent, new_x, new_y)	end
		end
	end, "MouseMove")
end

