local addon, rabc = ...

rabc.timeseg = 1
local lastUnitUpdate = Inspect.Time.Frame()
local function getThrottle()
	local now = Inspect.Time.Frame()
	elapsed = now - lastUnitUpdate
	if (elapsed >= (rabc.timeseg)) then lastUnitUpdate = now return true end
end

rabc.barloaded = {false, false, false, false, false, false, false, false, false, false, false} 
rabc.spellcount = 0
function rabc.setupBars()
	timer = getThrottle()
	if not timer then return end
	if tempsize ~= nil then
		rabc.createSlots()
		if tempsize ~= rabc.mainab[2]:GetWidth() then tempsize = nil rabc.timeseg = .1 end
	end
	if rabc.spellcountdone == true then return end
	for k, v in pairs(rabcSavedAbils) do
		if rabcSavedSettings.set == v.set then
----Macro List Loop
			if v.ismacro == true then
				rabc.nextabil = nil
			----------Next Ability Not on Cooldown-------	
				if rabcSavedSettings.macroshow == 1 then
					for i = 1, 12 do
						if v[i] and v[i].start == 0 and rabc.nextabil == nil then
							rabc.nextabil = v[i]
							rabc.mainslotframe[v.bar][v.slot]:SetTexture("Rift", v[i].icon)
							rabc.mainslotframe[v.bar][v.slot]:SetVisible(true)
						end
					end
				end
			---------Next Ability on Cooldown-------------
				if rabcSavedSettings.macroshow == 2 then
					local remainingtemp = 500
					for i = 1, 12 do
						if v[i] and v[i].duration > 0 and v[i].start > 0 then
							remaining = v[i].duration - (Inspect.Time.Frame() - v[i].start)
							if remaining < remainingtemp then
								remainingtemp = remaining
								rabc.nextabil = v[i]
							end
						end
					end
					if rabc.nextabil ~= nil then
						v.start = rabc.nextabil.start
						v.duration = rabc.nextabil.duration
						rabc.mainslotframe[v.bar][v.slot]:SetTexture("Rift", rabc.nextabil.icon)
						rabc.mainslotframe[v.bar][v.slot]:SetVisible(true)
					end
				end
			end
----Macro List Loop End
			if v.start > 0 then
				remaining = v.duration - (Inspect.Time.Frame() - v.start)
				if rabcSavedSettings.timer == 1 then
					if remaining < 60 then
						remain = tostring(math.floor(remaining))
					else
						remain = string.format("%d:%02d", math.floor(remaining / 60), math.floor(remaining) % 60)
					end
				end
				if rabcSavedSettings.timer == 2 then remain = tostring(math.floor(remaining)) end
				if remaining > 60 then rabc.mainslottext[v.bar][v.slot]:SetFontSize(rabcSavedColors[1].f) rabc.mainslottext[v.bar][v.slot]:SetFontColor(rabcSavedColors[1].r, rabcSavedColors[1].g, rabcSavedColors[1].b )end
				if remaining < 60 then rabc.mainslottext[v.bar][v.slot]:SetFontSize(rabcSavedColors[2].f) rabc.mainslottext[v.bar][v.slot]:SetFontColor(rabcSavedColors[2].r, rabcSavedColors[2].g, rabcSavedColors[2].b )end
				if remaining < 10 then rabc.mainslottext[v.bar][v.slot]:SetFontSize(rabcSavedColors[3].f) rabc.mainslottext[v.bar][v.slot]:SetFontColor(rabcSavedColors[3].r, rabcSavedColors[3].g, rabcSavedColors[3].b )end
				rabc.mainslotframe[v.bar][v.slot]:SetVisible(true)
				rabc.mainslottext[v.bar][v.slot]:SetVisible(true)
				rabc.mainslottext[v.bar][v.slot]:SetText(remain)
				-------------------Animate-----------------------
				if remaining < 1 and rabcSavedSettings.animate == true then
				rabc.mainslotframe[v.bar][v.slot]:SetWidth(rabc.mainslotframe[v.bar][v.slot]:GetWidth() +3)
				rabc.mainslotframe[v.bar][v.slot]:SetHeight(rabc.mainslotframe[v.bar][v.slot]:GetWidth() +3)
				rabc.mainslotframe[v.bar][v.slot]:SetTexture("Rift", v.icon)
				rabc.mainslottext[v.bar][v.slot]:SetFontSize(rabc.mainslottext[v.bar][v.slot]:GetFontSize() + math.floor(6/remaining))
				end
				-------------------------------------------------
				if remaining < .1 then
					rabc.mainslottext[v.bar][v.slot]:SetText("") 
					rabc.mainslotframe[v.bar][v.slot]:SetWidth(rabc.mainslotframe[v.bar][v.slot].origsize)
					rabc.mainslotframe[v.bar][v.slot]:SetHeight(rabc.mainslotframe[v.bar][v.slot].origsize)
					rabc.mainslotframe[v.bar][v.slot]:SetTexture(rabc.addonid, "Textures/blank.png")
				end
				if rabc.spellcount == 0 then rabc.spellcountdone = true end
			else
			rabc.mainslottext[v.bar][v.slot]:SetText("")
			end
		end
	end
end
function rabc.loadSettings()
	if rabcSavedSettings.timer == nil then rabcSavedSettings.timer = 1 end
	if rabcSavedSettings.include == nil then rabcSavedSettings.include = {true, true, true, true, true} end
	for k, v in pairs(rabcSavedAbils) do
		if v.start >0 then v.start = 0 print(v.name) end
		if v.ismacro == true then
			for i=1, 12 do
				if v[i] ~= nil  and v[i].start >0 then v[i].start = 0 print(v[i].name) end
			end
		end
	end

	rabc.createBars()
	rabc.createMinimapButton()
	rabc.createOptions()
end
function rabc.Unit_Availability_Full(h,t)
	for k,v in pairs(t) do
		if v == "player" then
			rabcSavedSettings.set = Inspect.TEMPORARY.Role()
		end
	end
end
function rabc.cooldownBegin(h, cooldowns)
	for key, val in pairs(cooldowns) do
		if val > 1.5 then
			for k, v in pairs (rabcSavedAbils) do
				if key == v.id then
					v.start = Inspect.Time.Frame()
					v.duration = val
					v.watch = true
					rabc.spellcount = rabc.spellcount + 1
					rabc.spellcountdone = false
				end
				if v.ismacro == true then
					for i = 1, 12 do
						if v[i] and key == v[i].id then
							v[i].start = Inspect.Time.Frame()
							v[i].duration = val
							v[i].watch = true
							rabc.spellcount = rabc.spellcount + 1
							rabc.spellcountdone = false
						end
					end
				end
			end
		end
	end
end
function rabc.cooldownEnd(h, cooldowns)
	for key, val in pairs(cooldowns) do
		for k, v in pairs (rabcSavedAbils) do
			if key == v.id and v.watch == true then
				v.start = 0
				v.watch = false
				rabc.spellcount = rabc.spellcount - 1
				rabc.mainslottext[v.bar][v.slot]:SetText("")
				rabc.mainslotframe[v.bar][v.slot]:SetWidth(rabc.mainslotframe[v.bar][v.slot].origsize)
				rabc.mainslotframe[v.bar][v.slot]:SetHeight(rabc.mainslotframe[v.bar][v.slot].origsize)
				rabc.mainslotframe[v.bar][v.slot]:SetTexture(rabc.addonid, "Textures/blank.png")
			end
			if v.ismacro == true then
					v.start = 0
				for i = 1, 12 do
					if v[i] and key == v[i].id and v[i].watch == true then
						v[i].start = 0
						v[i].watch = false
						rabc.spellcount = rabc.spellcount - 1
						rabc.mainslotframe[v.bar][v.slot]:SetWidth(rabc.mainslotframe[v.bar][v.slot].origsize)
						rabc.mainslotframe[v.bar][v.slot]:SetHeight(rabc.mainslotframe[v.bar][v.slot].origsize)
						rabc.mainslottext[v.bar][v.slot]:SetText("")
					end
				end
			end
		end
	end
end
function rabc.RoleChanged(h, num)
	if rabcSavedSettings.set ~= num then
		rabcSavedSettings.set = num

		for k, v in pairs(rabcSavedAbils) do
			a = {} i = 1
			for m in string.gmatch(k, "%d+") do a[i] = m i = i + 1 end
			bar = tonumber(a[2]) slot = tonumber(a[3])
			rabc.mainslotframe[bar][slot]:SetTexture(rabc.addonid, "Textures/blank.png")
			rabc.mainslottext[bar][slot]:SetText("")
		end
		rabc.configOptionsBText:SetText("Role #" .. rabcSavedSettings.set)
		rabc.createAbilityList()
	end
end
function rabc.SlashCommand(hEvent, params)
	if params == "reset" then
		rabcSavedSettings = {set = 1, buttonx = 900, buttony = 500, mainl = 1, maint = 1, mainr = 1, mainb = 1, locked = false, macroshow = 1, animate = true}
		rabcSavedColors = {{f = 16, r = 0, g = 0.8, b = 0}, {f = 24, r = 0.15, g = 0.5, b = 1}, {f = 30, r = 0.7, g = 0.3, b = 1}}
		rabcSavedAbils = {}
		rabc.createBars()
		for i = 1, 11 do
			local bar = select(i, UI.Native.BarMain, UI.Native.BarBottom1, UI.Native.BarBottom2, UI.Native.BarBottom3, UI.Native.BarBottom4, UI.Native.BarBottom5, UI.Native.BarBottom6, UI.Native.BarSide1, UI.Native.BarSide2, UI.Native.BarSide3, UI.Native.BarSide4)
			rabc.mainab[i].enabled = bar:GetLoaded()
			rabc.OptionsRadioTabA[i]:SetEnabled(rabc.mainab[i].enabled)
			rabc.OptionsRadioTabA[i]:SetSelected(false, true)
		end
		for i = 1, 12 do
			rabc.OptionsCheckTabA[i]:SetEnabled(false)
			rabc.OptionsTextBTabA[i]:SetText("")
		end
		rabc.configOptionsTab:SetActiveTab(1)
		rabc.config:SetVisible(rabcSavedSettings.locked == false)
		if rabcSavedSettings.locked == true then rabc.configSliderButton:SetText("Unlock Overlay") else rabc.configSliderButton:SetText("Lock Overlay") end

		rabc.createAbilityList()
		print ("*****RiftActionBarCooldowns settings have been reset back to default values*****")
	elseif params == "config" then
		if rabc.config:GetVisible() == false then
			rabc.createAbilityList()
			rabc.config:SetVisible(true)
		end
	else
		print ("--------------------------------")
		print ("RiftActionBarCooldowns Help Menu")
		print ("--------------------------------")
		print ("/rabc          -- Shows this text")
		print ("/rabc config   -- Open Configuration window")
		print ("/rabc reset    -- Reset default addon settings")
	end
end

Command.Event.Attach(Event.Addon.Startup.End, rabc.loadSettings, "loadSettings")
Command.Event.Attach(Event.Unit.Availability.Full, rabc.Unit_Availability_Full, "loadSettings")
Command.Event.Attach(Event.Ability.New.Cooldown.Begin, rabc.cooldownBegin, "loadSettings")
Command.Event.Attach(Event.Ability.New.Cooldown.End, rabc.cooldownEnd, "loadSettings")
Command.Event.Attach(Event.System.Update.Begin, rabc.setupBars, "setupBars")
Command.Event.Attach(Event.TEMPORARY.Role, rabc.RoleChanged, "roleChanged")
Command.Event.Attach(Command.Slash.Register("rabc"), rabc.SlashCommand, "rabc.SlashCommand")

UI.Native.BarBottom1:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[2] = self:GetLoaded() end, "Layout")
UI.Native.BarBottom2:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[3] = self:GetLoaded() end, "Layout")
UI.Native.BarBottom3:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[4] = self:GetLoaded() end, "Layout")
UI.Native.BarBottom4:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[5] = self:GetLoaded() end, "Layout")
UI.Native.BarBottom5:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[6] = self:GetLoaded() end, "Layout")
UI.Native.BarBottom6:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[7] = self:GetLoaded() end, "Layout")
UI.Native.BarSide1:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[8] = self:GetLoaded() end, "Layout")
UI.Native.BarSide2:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[9] = self:GetLoaded() end, "Layout")
UI.Native.BarSide3:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[10] = self:GetLoaded() end, "Layout")
UI.Native.BarSide4:EventAttach(Event.UI.Native.Loaded, function(self, h) rabc.barloaded[11] = self:GetLoaded() end, "Layout")





