local addon, rabc = ...

function rabc.createBars()
	for i = 1, 11 do
		local bar = select(i, UI.Native.BarMain, UI.Native.BarBottom1, UI.Native.BarBottom2, UI.Native.BarBottom3, UI.Native.BarBottom4, UI.Native.BarBottom5, UI.Native.BarBottom6, UI.Native.BarSide1, UI.Native.BarSide2, UI.Native.BarSide3, UI.Native.BarSide4)
		if i == 1 then
			rabc.mainab[i]:SetPoint("TOPLEFT", bar, "TOPLEFT", rabcSavedSettings.mainl, rabcSavedSettings.maint)
			rabc.mainab[i]:SetPoint("BOTTOMRIGHT", bar, "BOTTOMRIGHT", -(rabcSavedSettings.mainr), -(rabcSavedSettings.mainb))
		else
			rabc.mainab[i]:SetPoint("TOPLEFT", bar, "TOPLEFT")
			rabc.mainab[i]:SetPoint("BOTTOMRIGHT", bar, "BOTTOMRIGHT")
		end
		rabc.mainab[i]:SetVisible(false)
	end
	tempsize = rabc.mainab[2]:GetWidth()
	rabc.mainab[1]:SetVisible(rabcSavedSettings.locked == false)
	rabc.createbarscheck = true
	--------------------------------------------
end
function rabc.createSlots()
	for i = 1, 11 do
		if i < 8 then
			rabc.mainab[i]:SetTexture(rabc.addonid, "Textures/overlayh.png")
			for j = 1, 12 do
				rabc.mainslotframe[i][j]:SetPoint("LEFTCENTER", rabc.mainab[i], "LEFTCENTER", 4 + (rabc.mainab[i]:GetWidth() / 12) * (j - 1), 0)
				rabc.mainslotframe[i][j]:SetHeight(rabc.mainab[i]:GetHeight() - 8)
				rabc.mainslotframe[i][j]:SetWidth(rabc.mainab[i]:GetHeight() - 8)
				rabc.mainslotframe[i][j]:SetLayer(1)
			end	
		else
			rabc.mainab[i]:SetTexture(rabc.addonid, "Textures/overlayv.png")
			for j = 1, 12 do
				rabc.mainslotframe[i][j]:SetPoint("TOPCENTER", rabc.mainab[i], "TOPCENTER", 0, 3 + (rabc.mainab[i]:GetHeight() / 12) * (j - 1))
				rabc.mainslotframe[i][j]:SetHeight(rabc.mainab[i]:GetWidth() - 6)
				rabc.mainslotframe[i][j]:SetWidth(rabc.mainab[i]:GetWidth() - 6)
				rabc.mainslotframe[i][j]:SetLayer(1)
			end	
		end
		for j = 1, 12 do
			rabc.mainslotframe[i][j]:SetVisible(false)
			rabc.mainslotframe[i][j].origsize = rabc.mainslotframe[i][j]:GetHeight()
			rabc.mainslottext[i][j]:SetText("")
			rabc.mainslottext[i][j]:SetVisible(false)
			rabc.mainslottext[i][j]:SetPoint("CENTER", rabc.mainslotframe[i][j], "CENTER")
			rabc.mainslottext[i][j]:SetEffectGlow(rabc.glowTable)
			rabc.mainslottext[i][j]:SetFontSize(20)
			rabc.mainslottext[i][j]:SetLayer(2)
		end
	end
end
function rabc.createMinimapButton()
	rabc.minimapbutton:SetTexture("Rift", "DragonMote_fire.png.dds")
	rabc.minimapbutton:SetHeight(48)
	rabc.minimapbutton:SetWidth(48)
	rabc.minimapbutton:SetVisible(true)
	if not MINIMAPDOCKER then
		rabc.minimapbutton:SetPoint("TOPLEFT", rabc.context, "TOPLEFT",  rabcSavedSettings.buttonx,  rabcSavedSettings.buttony)
	end
end
function rabc.dragminimapbutton(window, x, y)
	rabcSavedSettings.buttonx = x
	rabcSavedSettings.buttony = y
	rabc.minimapbutton:SetPoint("TOPLEFT", rabc.context, "TOPLEFT",  rabcSavedSettings.buttonx,  rabcSavedSettings.buttony)
end
if MINIMAPDOCKER then
	MINIMAPDOCKER.Register(rabc.addonid, rabc.minimapbutton)
else
rabc.dragframe(rabc.minimapbutton, rabc.dragminimapbutton)
end
rabc.minimapbutton:EventAttach(Event.UI.Input.Mouse.Right.Down, function()
	if rabc.config:GetVisible() == false then
		for i = 1, 11 do
			local bar = select(i, UI.Native.BarMain, UI.Native.BarBottom1, UI.Native.BarBottom2, UI.Native.BarBottom3, UI.Native.BarBottom4, UI.Native.BarBottom5, UI.Native.BarBottom6, UI.Native.BarSide1, UI.Native.BarSide2, UI.Native.BarSide3, UI.Native.BarSide4)
			rabc.mainab[i].enabled = bar:GetLoaded()
			rabc.OptionsRadioTabA[i]:SetEnabled(rabc.mainab[i].enabled)
		end
		for i = 1, 12 do
			rabc.OptionsCheckTabA[i]:SetEnabled(false)
		end
		rabc.createAbilityList()
		rabc.config:SetVisible(true)
	end
end, "RightDown" )
